"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Highlighter = void 0;
const schemes = __importStar(require("./colorSchemes"));
const emojis = __importStar(require("./emojiScheme"));
const styles = __importStar(require("./styles"));
const stringHelpers_1 = require("./stringHelpers");
const type_guards_1 = require("../utils/type-guards");
const { log } = console;
class Highlighter {
    constructor(config) {
        var _a;
        this.logger = (args) => {
            var _a;
            const css = this.getStyles(args.color);
            const emoji = (_a = this.emojis[args.color]) !== null && _a !== void 0 ? _a : "";
            return stringHelpers_1.transform({
                val: (v) => type_guards_1.isObject(v) ? `%c ${JSON.stringify(v, null, 2)} ` : `%c ${v} `,
                str: (s) => (type_guards_1.isEmptyString(s.trim()) ? `` : `%c ${s.trim()} `),
                merge: (xs, xy) => {
                    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
                    const line = css.line(this.scheme) + (((_b = (_a = this.styles).line) === null || _b === void 0 ? void 0 : _b.call(_a, this.scheme)) || "");
                    const value = css.value(this.scheme) +
                        (((_d = (_c = this.styles).value) === null || _d === void 0 ? void 0 : _d.call(_c, this.scheme)) || "") +
                        line;
                    const string = css.string(this.scheme) +
                        (((_f = (_e = this.styles).string) === null || _f === void 0 ? void 0 : _f.call(_e, this.scheme)) || "") +
                        line;
                    const prepend = css.prepend(this.scheme) +
                        (((_h = (_g = this.styles).prepend) === null || _h === void 0 ? void 0 : _h.call(_g, this.scheme)) || "") +
                        line;
                    const append = css.append(this.scheme) +
                        (((_k = (_j = this.styles).append) === null || _k === void 0 ? void 0 : _k.call(_j, this.scheme)) || "") +
                        line;
                    const colors = [...(emoji ? [value, emoji] : [])];
                    xs.forEach((s, i) => {
                        if (xy[i - 1] !== undefined) {
                            colors.push(value);
                        }
                        if (!type_guards_1.isEmptyString(s)) {
                            colors.push(string);
                        }
                    });
                    colors[0] = colors[0] + prepend;
                    colors[colors.length - 1] = colors[colors.length - 1] + append;
                    return log(stringHelpers_1.emojify((emoji ? "%c %s " : "") + stringHelpers_1.mergeXY(xs, xy)), ...colors);
                },
            });
        };
        this.scheme = schemes[config.theme];
        this.emojis = emojis[config.theme];
        this.styles = (_a = config.styles) !== null && _a !== void 0 ? _a : {};
        this.getStyles = styles[config.theme];
    }
    get themeColors() {
        const colors = Object.keys(this.scheme);
        return colors.reduce((acc, key) => {
            return Object.assign(Object.assign({}, acc), { [key]: this.logger({ color: key }) });
        }, {});
    }
    get highlight() {
        return this.themeColors;
    }
}
exports.Highlighter = Highlighter;
