"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emojify = exports.transform = exports.mergeXY = void 0;
const common_1 = require("../utils/common");
const emojis_1 = require("./emojis");
function mergeXY(xs, ys) {
    return xs.reduce((acc, str, i) => {
        return `${acc}${ys[i - 1] ? ys[i - 1] : ""}${str}`;
    }, "");
}
exports.mergeXY = mergeXY;
const transform = (transformers = { val: common_1.identity, str: common_1.identity, merge: mergeXY }) => (strings, ...values) => {
    return transformers.merge(strings.map(transformers.str), values.map(transformers.val));
};
exports.transform = transform;
const emojify = (s) => {
    let emoji;
    for (emoji in emojis_1.emojis) {
        s = s.replace(new RegExp(`:${emoji}:`, "gi"), emojis_1.emojis[emoji]);
    }
    return s;
};
exports.emojify = emojify;
