"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unicorn = exports.dracula = exports.molokai = exports.hamburger = exports.template = void 0;
const template = (color) => ({
    value: (scheme) => `background: ${scheme[color]}; color: ${scheme["background"]};`,
    string: (scheme) => `background: ${scheme["background"]}; color: ${scheme[color]};`,
    line: (scheme) => "font-size: 1.5em;",
    append: (scheme) => "",
    prepend: (scheme) => "",
});
exports.template = template;
const hamburger = (color) => ({
    value: (scheme) => `background: ${scheme[color]}; color: ${scheme["background"]}; font-weight: bold;`,
    string: (scheme) => `background: ${scheme["background"]}; color: ${scheme[color]};`,
    line: (scheme) => "font-family: Arial, sans-serif; font-size: 1.5em;",
    append: (scheme) => "font-size: 1.5em;",
    prepend: (scheme) => "",
});
exports.hamburger = hamburger;
const molokai = (color) => ({
    value: (scheme) => `background: ${scheme[color]}; color: ${scheme["background"]};`,
    string: (scheme) => `background: ${scheme["background"]}; color: ${scheme[color]};`,
    line: (scheme) => "font-size: 1.5em; line-height:1.8em; border-bottom: 4px solid white;",
    append: (scheme) => "",
    prepend: (scheme) => "",
});
exports.molokai = molokai;
const dracula = (color) => ({
    value: (scheme) => `background: ${scheme[color]}; color: ${scheme["background"]};`,
    string: (scheme) => `background: ${scheme["background"]}; color: ${scheme[color]};`,
    line: (scheme) => "font-size: 1.5em;",
    append: (scheme) => "",
    prepend: (scheme) => "",
});
exports.dracula = dracula;
const unicorn = (color) => ({
    value: (scheme) => `background: ${scheme[color]}; color: ${scheme["background"]};`,
    string: (scheme) => {
        if (color === "gradient") {
            return `background: ${scheme["background"]}; color: hotpink;`;
        }
        else {
            return `background: ${scheme["background"]}; color: ${scheme[color]};`;
        }
    },
    line: (scheme) => "font-size: 1.5em;",
    append: (scheme) => "border-left: 4px solid white;",
    prepend: (scheme) => "",
});
exports.unicorn = unicorn;
