import * as schemes from "./colorSchemes";
export declare type Schemes = typeof schemes;
export declare type SchemeName = Extract<keyof Schemes, string>;
export declare type Scheme<Key extends SchemeName> = {
    [Index in SchemeName]: Schemes[Index];
}[Key] & {
    background: string;
};
export declare type Color<T extends SchemeName> = Extract<keyof Scheme<T>, string>;
export declare type Style<T extends SchemeName> = {
    value: (colors: Scheme<T>) => string;
    string: (colors: Scheme<T>) => string;
    line: (colors: Scheme<T>) => string;
    append: (colors: Scheme<T>) => string;
    prepend: (colors: Scheme<T>) => string;
};
export declare type EmojiScheme<T extends SchemeName> = Partial<Record<Color<T>, string>>;
export declare type GetStyles<T extends SchemeName> = (color: Color<T>) => Style<T>;
